#!/usr/bin/perl
# 
# library - cms 
# == scripted by Takuya Otani ========
# == copyright (C) SimpleBoxes 2004 ==

{
	my $aVersion_ = 0.24;
	# 
	# ver 0.00 [2004/04/20] 
	# ver 0.01 [2004/05/20] sbcms_main ɲ
	# ver 0.02 [2004/05/20] sbcms_listblock, sbcms_recent_list, sbcms_entrylist, sbcms_extract_entry, sbcms_entry ɲ
	# ver 0.03 [2004/05/20] sbcms_delblock ɲ (sequel ֥åк)
	# ver 0.04 [2004/05/21] sbcms_calendar, sbcms_amazon, sbcms_entry_catlink, sbcms_entry_authlink, sbcms_permalink, sbcms_monthlylink ɲ
	# ver 0.05 [2004/05/23] sbcms_tbauto_rdf ɲ
	# ver 0.06 [2004/05/24] ֤Ǥڡɽ褦 / sbcms_amazon ɲ
	# ver 0.07 [2004/05/27] sbcms_calendar, sbcms_permalink, sbcms_monthlylink, sbcms_parseblock ѹ
	# ver 0.08 [2004/05/28] sbcms_listmain ɲ
	# ver 0.09 [2004/05/31] ȥåץڡ˥ȥꥢʤɤɽƤޤХ
	# ver 0.10 [2004/06/02] sbcms_make_summary ɲ
	# ver 0.11 [2004/06/04] ȥåХåʤХ / trackback_url ѹ
	# ver 0.12 [2004/06/04] sbcms_recent_list ѹ(ȡȥåХåꥹȤɽ)
	# ver 0.13 [2004/06/08] ʸ url ư󥯤б
	# ver 0.14 [2004/06/10] sbcms_entry_catlink, sbcms_entry_comment, sbcms_listblock, sbcms_entry_authlink ΥХ
	# ver 0.15 [2004/06/14] ȥ⸡оݤ
	# ver 0.16 [2004/06/15] ڡ¿׻ƤޤХ
	# ver 0.17 [2004/06/17] sbcms_entry_catid ɲ / {user_id},{entry_disp_time},{category_id},{comment_count},{trackback_count} ɲ
	# ver 0.18 [2004/06/21] åϢ
	# ver 0.19 [2004/07/05] ꥹɽ
	# ver 0.20 [2004/07/09] ڡʥӥΥХ
	# ver 0.21 [2004/07/12] ȥǽ
	# ver 0.22 [2004/07/12] ȡȥåХåꥹȤְ֤äƤΤ
	# ver 0.23 [2004/07/19] ȥ꡼ʥӥΥХ
	# ver 0.24 [2004/07/20] {amazon_item}ɽʤХ
	# ver 0.25 [2004/07/20] ȥåХåγɽɽ¤褦
	# --[ѤƤ륰Хѿ]-----------------------
	# @gTemp : ƥץ졼ƤǼ(֥åʬ¸)
	# %gData : Ǽ => $gData{}[֥åֹ]
	# -----------------------------------------------------
	require 'sbtext.pl';
	require 'sbfile.pl';
	require 'sbtime.pl';
}
sub sbcms_parseblock {
	my $text = shift; # ϥѥ᡼
	my $num = 0;
	my $sequel = 0;
	my $cur = '_main';
	my @block = ();
	{ # 
		$text = &sbtxt_det($text);
		$text = &sbtxt_lfconv($text,1);
		@gTemp = ();
		$gTemp[$num] = {};
		$gTemp[$num]{'tag'} = [];
		$gTemp[$num]{'block'} = $cur;
		push(@block,$cur);
	}
	foreach my $line (split("\n",$text)) {
		if ($line =~ /<\!-- BEGIN (.+) -->/) {
			$num++;
			$cur = $1;
			$gTemp[$num] = {};
			$gTemp[$num]{'tag'} = [];
			$gTemp[$num]{'block'} = $cur;
			if ($cur eq 'entry' and $gEnv{'basic'}{'marking'}) { # ȥ꡼Ѥ̽
				$gTemp[$num]{'text'} .= '{sb_entry_marking}' . "\n";
				push(@{$gTemp[$num]{'tag'}},'{sb_entry_marking}');
			}
			push(@block,$cur);
			next;
		} elsif (index($line,'<!-- END ') > -1) {
			if ($cur eq 'comment_area') { # å js Τ̽
				$gTemp[$num]{'text'} .= '{sb_comment_js}' . "\n";
				push(@{$gTemp[$num]{'tag'}},'{sb_comment_js}');
			}
			$num++;
			pop(@block);
			$cur = $block[$#block];
			$gTemp[$num] = {};
			$gTemp[$num]{'tag'} = [];
			$gTemp[$num]{'block'} = $cur;
			next;
		}
		if ($line =~ /\{.*?\}/) {
			push(@{$gTemp[$num]{'tag'}},($line =~ /(\{.*?\})/g));
		}
		$gTemp[$num]{'text'} .= $line . "\n";
	}
	return();
}
sub sbcms_output {
	my $output = ''; # ϥѥ᡼
	for (my $i=0;$i<@gTemp;$i++) {
		my $rep  = ($gTemp[$i]{'block'} eq '_main') ? 1 : $gEnv{'block'}{$gTemp[$i]{'block'}};
		for (my $j=0;$j<$rep;$j++) {
			my @lines = split("\n",$gTemp[$i]{'text'});
			for (my $k=0;$k<@lines;$k++) {
				foreach my $key (@{$gTemp[$i]{'tag'}}) {
					$lines[$k] =~ s/$key/$gData{$key}[$j]/g;
				}
				$output .= $lines[$k] . "\n";
			}
		}
	}
	return($output);
}
sub sbcms_delblock { # ֥åפʥ֥å (ex. sequel in entry)
	my $block = shift; # ϥѥ᡼ / ֥å̾
	my $check = 0;
	for (my $i=0;$i<@gTemp;$i++) {
		next if ($gTemp[$i]{'block'} ne $block);
		$check = $i;
		last;
	}
	if ($check > 0  and $check < $#gTemp and $gTemp[$check - 1]{'block'} eq $gTemp[$check + 1]{'block'}) { # оݥ֥åξ岼Ʊ
		$gTemp[$check - 1]{'text'} .= $gTemp[$check + 1]{'text'}; # ֥åƤΥޡ
		push(@{$gTemp[$check - 1]{'tag'}},@{$gTemp[$check + 1]{'tag'}}); # ѥΥޡ
		splice(@gTemp,$check,2); # ֥å
	}
	return();
}
sub sbcms_main {
	my $mode = shift;
	foreach my $type ('ent','com','tb','aws','user','link','cat') { # ꥹȥեɹ
		&sbfile_read_datafile($type) if ($gIn{'num'}{$type} eq '');
	}
	&sbcms_amazon();  # ᾦ
	&sbcms_listmain($mode); # ꥹȷ
	CMS_MAIN: {
		$_ = $mode;
		/^user/ && do { # ץեɽ
			$gData{'{selected_entry_list}'}[0] = $gData{'{latest_entry_list}'}[0]; # 򥨥ȥꥹȤϼȴ
			$gData{'{profile_name}'}[0] = $gData{'user'}[$gIn{'pid'}]{'real'};
			$gData{'{profile_description}'}[0] = &sbtxt_lfconv(&sbtxt_det($gData{'user'}[$gIn{'pid'}]{'prof'}),2);
			$gEnv{'block'}{'selected_entry'} = 1;
			$gEnv{'block'}{'profile_area'} = 1;
			last CMS_MAIN;
		};
		/^ent/ && do { # ̥ȥ꡼ɽ
			&sbcms_entry($gIn{'eid'},0,'ent');
			$gData{'{selected_entry_list}'}[0] = $gData{'{latest_entry_list}'}[0]; # 򥨥ȥꥹȤϼȴ
			$gEnv{'block'}{'selected_entry'} = 1;
			$gEnv{'block'}{'entry'} = 1;
			$gEnv{'block'}{'option'} = 1;
			$gEnv{'block'}{'sequel'} = 1;
			last CMS_MAIN;
		};
		#  / ȥå
		my @entry = &sbcms_extract_entry($mode);
		my $num = 0;
		foreach my $hash ( @entry ) {
			&sbcms_entry($$hash{'id'},$num,'');
			$num++;
		}
		&sbcms_delblock('sequel');
		$gEnv{'block'}{'entry'} = $num;
	} # end of CMS_MAIN
	{ # ̥֥å
		$gData{'{blog_name}'}[0] = '<a href="' . $gData{'{site_top}'}[0] . '">' . $gEnv{'conf'}{'blog_title'} . '</a>';
		$gData{'{blog_description}'}[0] = &sbtxt_lfconv($gEnv{'conf'}{'blog_desc'},2);
		$gData{'{collect_log}'}[0]  = '<script type="text/javascript" src="' . $gEnv{'srv'}{'base'} . $gEnv{'dir'}{'log'} . $gEnv{'file'}{'logjs'} . '"></script>';
		$gData{'{collect_log}'}[0] .= '<noscript><p><img src="' . $gEnv{'srv'}{'cgi'} . $gEnv{'basic'}{'cnt'} . '" width="1" height="1" alt="" /></p></noscript>';
		$gData{'{show_counter}'}[0] = '<script type="text/javascript" src="' . $gEnv{'srv'}{'cgi'} . $gEnv{'basic'}{'cnt'} . '?disp=on"></script>';
		$gEnv{'block'}{'title'} = 1;
	}
	return();
}
sub sbcms_listmain {
	$mode = shift;
	if ($mode eq 'ent' and $gEnv{'conf'}{'entry_archive'} eq 'Individual') {
		foreach my $elem ( keys(%{$gEnv{'listjs'}}) ) {
			my $check = $gEnv{'listjs'}{$elem}{'d'};
			$check = ($check ne '') ? $gData{'num'}{$check} : 1;
			if ($check) {
				$gData{'{' . $elem . '}'}[0]  = '<script type="text/javascript" charset="' . $gMsg{'parts'}{'code'} . '" src="';
				$gData{'{' . $elem . '}'}[0] .= $gEnv{'srv'}{'base'} . $gEnv{'dir'}{'log'} . $gEnv{'listjs'}{$elem}{'js'} . '"></script>';
				$gEnv{'block'}{$gEnv{'listjs'}{$elem}{'b'}} = 1;
			} else {
				$gData{'{' . $elem . '}'}[0] = '';
				$gEnv{'block'}{$gEnv{'listjs'}{$elem}{'b'}} = 0;
			}
		}
	} else {
		my $month = $gIn{'month'};
		$month = substr($gIn{'day'},0,6) if ($gIn{'day'} ne '');
		&sbcms_listblock();   # ꥹȥ֥å
		&sbcms_recent_list(); # ǿ / ȥåХå
		&sbcms_entrylist();   # ȥ꡼Ϣ֥å (ǿȥ꡼ / ƥ꡼ / )
		&sbcms_calendar($month); # 
	}
	return();
}
sub sbcms_listblock {
	if ($gData{'num'}{'user'}) { # 桼ꥹ
		$gData{'{user_list}'}[0] = '<ul>';
		foreach my $hash ( @{$gData{'user'}} ) {
			next if ($$hash{'id'} eq '');
			$gData{'{user_list}'}[0] .= '<li><a href="' . $gData{'{site_cgi}'}[0] . '?pid=' . $$hash{'id'} . '">';
			$gData{'{user_list}'}[0] .= ($$hash{'real'} ne '') ? $$hash{'real'} : $$hash{'name'};
			$gData{'{user_list}'}[0] .= '</a></li>' . "\n";
		}
		$gData{'{user_list}'}[0] .= '</ul>';
		$gEnv{'block'}{'profile'} = 1;
	}
	if ($gData{'num'}{'link'}) { # 󥯥ꥹ
		$gData{'{link_list}'}[0] = '<ul>';
		foreach my $hash ( @{$gData{'link'}} ) {
			next if ($$hash{'id'} eq '');
			$gData{'{link_list}'}[0] .= '<li><a href="' . $$hash{'url'} . '" target="_blank">';
			$gData{'{link_list}'}[0] .= $$hash{'name'} . '</a></li>' . "\n";
		}
		$gData{'{link_list}'}[0] .= '</ul>';
		$gEnv{'block'}{'link'} = 1;
	}
	return();
}
sub sbcms_amazon {
	if ($gData{'num'}{'aws'}) { # ᾦ
		my @order = @{$gData{'aws'}};
		my $num = 0;
		@order = sort { $$b{'mod'} <=> $$a{'mod'} } @order;
		foreach my $hash ( @order ) {
			next if ($$hash{'id'} eq '');
			next if ($$hash{'stat'} == 0); # ƥФ
			$gData{'{amazon_ProductName}'}[$num]    = $$hash{'name'};
			$gData{'{amazon_Catalog}'}[$num]        = $$hash{'cat'};
			$gData{'{amazon_Creator}'}[$num]        = &sbtxt_lfconv($$hash{'cre'},2);
			$gData{'{amazon_ReleaseDate}'}[$num]    = $$hash{'date'};
			$gData{'{amazon_Manufacturer}'}[$num]   = $$hash{'make'};
			$gData{'{amazon_ImageUrlSmall}'}[$num]  = $$hash{'ism'};
			$gData{'{amazon_ImageUrlMedium}'}[$num] = $$hash{'imd'};
			$gData{'{amazon_ImageUrlLarge}'}[$num]  = $$hash{'ilg'};
			$gData{'{amazon_Availability}'}[$num]   = $$hash{'ava'};
			$gData{'{amazon_ListPrice}'}[$num]      = $$hash{'lpr'};
			$gData{'{amazon_OurPrice}'}[$num]       = $$hash{'opr'};
			$gData{'{amazon_comment}'}[$num]        = &sbtxt_lfconv($$hash{'msg'},2);
			$gData{'{amazon_url}'}[$num]            = $$hash{'url'};
			$gData{'{amazon_item}'}[$num]  = '<div class="amazon">' . "\n";
			$gData{'{amazon_item}'}[$num] .= '<a href="' . $$hash{'url'} . '" target="_blank">';
			$gData{'{amazon_item}'}[$num] .= '<img border="0" src="' . $$hash{'imd'} . '" alt="' . $$hash{'name'} . '" class="amazon_pict" /></a>' . "\n";
			$gData{'{amazon_item}'}[$num] .= '<div class="amazon_text">' . "\n";
			$gData{'{amazon_item}'}[$num] .= '<a href="' . $$hash{'url'} . '" target="_blank"><strong>' . $$hash{'name'} . '</strong></a><br />' . "\n";
			$gData{'{amazon_item}'}[$num] .= $$hash{'make'} . '<br />' . &sbtxt_lfconv($$hash{'msg'},2) . '</div>' . "\n" . '</div>' . "\n";
			$num++;
			last if ($num == $gEnv{'conf'}{'aws_disp'});
		}
		$gEnv{'block'}{'amazon'} = $num;
	}
}
sub sbcms_recent_list {
	if ($gData{'num'}{'com'}) { # ǿ
		my $num = 0;
		my @order = @{$gData{'com'}};
		@order = sort { $$b{'date'} <=> $$a{'date'} } @order;
		$gData{'{recent_comment_list}'}[0] = '<ul>';
		foreach my $hash ( @order ) {
			next if ($$hash{'id'} eq '');
			next if ($$hash{'stat'} == 0); # ̤ǧȤФ
			next if ($gData{'ent'}[$$hash{'eid'}]{'stat'} == 0); # ȥ꡼Ф륳
			$gData{'{recent_comment_list}'}[0] .= '<li>' . $gData{'ent'}[$$hash{'eid'}]{'subj'} . '<br />' . $gMsg{'parts'}{'arrow'} . ' ';
			$gData{'{recent_comment_list}'}[0] .= '<a href="' . &sbcms_permalink($$hash{'eid'},$gData{'ent'}[$$hash{'eid'}]{'date'},'com') . '">';
			$gData{'{recent_comment_list}'}[0] .= $$hash{'auth'} . &sbtime_stamp($$hash{'date'},' (%mo/%dy)',$gEnv{'conf'}{'timezone'},'en');
			$gData{'{recent_comment_list}'}[0] .= '</a></li>' . "\n";
			$num++;
			last if ($num == $gEnv{'conf'}{'com_disp'});
		}
		$gData{'{recent_comment_list}'}[0] .= '</ul>';
		$gEnv{'block'}{'recent_comment'} = 1;
	}
	if ($gData{'num'}{'tb'}) { # ǿȥåХå
		my $num = 0;
		my @order = @{$gData{'tb'}};
		@order = sort { $$b{'date'} <=> $$a{'date'} } @order;
		$gData{'{recent_trackback_list}'}[0] = '<ul>';
		foreach my $hash ( @order ) {
			next if ($$hash{'id'} eq '');
			next if ($$hash{'stat'} == 0); # ̤ǧȥåХåФ
			next if ($gData{'ent'}[$$hash{'eid'}]{'stat'} == 0); # ȥ꡼ФȥåХå
			$gData{'{recent_trackback_list}'}[0] .= '<li>' . $gData{'ent'}[$$hash{'eid'}]{'subj'} . '<br />' . $gMsg{'parts'}{'arrow'} . ' ';
			$gData{'{recent_trackback_list}'}[0] .= '<a href="' . &sbcms_permalink($$hash{'eid'},$gData{'ent'}[$$hash{'eid'}]{'date'},'tb') . '">';
			$gData{'{recent_trackback_list}'}[0] .= $$hash{'name'} . &sbtime_stamp($$hash{'date'},' (%mo/%dy)',$gEnv{'conf'}{'timezone'},'en');
			$gData{'{recent_trackback_list}'}[0] .= '</a></li>' . "\n";
			$num++;
			last if ($num == $gEnv{'conf'}{'tb_disp'});
		}
		$gData{'{recent_trackback_list}'}[0] .= '</ul>';
		$gEnv{'block'}{'recent_trackback'} = 1;
	}
	return();
}
sub sbcms_entrylist {
	my (%cat,%mon) = ();
	if ($gData{'num'}{'ent'}) { # ǿȥ꡼ꥹ
		my $dt = $gEnv{'disptime'}{$gEnv{'conf'}{'disptime'}}{'dateinlist'};
		my $tl = $gEnv{'disptime'}{$gEnv{'conf'}{'disptime'}}{'time_lang'};
		my $num = 0;
		my @order = @{$gData{'ent'}};
		@order = sort { $$b{'date'} <=> $$a{'date'} } @order;
		$gData{'{latest_entry_list}'}[0] = '<ul>';
		foreach my $hash ( @order ) {
			next if ($$hash{'id'} eq '');
			next if ($$hash{'stat'} == 0); # ȥ꡼Ф
			if ($num < $gEnv{'conf'}{'newent_disp'}) {
				$gData{'{latest_entry_list}'}[0] .= '<li><a href="' . &sbcms_permalink($$hash{'id'},$$hash{'date'}) . '">';
				$gData{'{latest_entry_list}'}[0] .= $$hash{'subj'} . '</a>';
				$gData{'{latest_entry_list}'}[0] .= &sbtime_stamp($$hash{'date'},$dt,$gEnv{'conf'}{'timezone'},$tl) . '</li>' . "\n";
			}
			$cat{$$hash{'cat'}}++;
			$mon{&sbtime_stamp($$hash{'date'},'%yr%mo',$gEnv{'conf'}{'timezone'},'en')}++;
			$num++;
		}
		$gData{'{latest_entry_list}'}[0] .= '</ul>';
		$gEnv{'block'}{'latest_entry'} = 1;
	}
	if ($gData{'num'}{'cat'}) { # ƥ꡼ꥹ
		$gData{'{category_list}'}[0] = '<ul>';
		foreach my $hash ( @{$gData{'cat'}} ) {
			next if ($$hash{'id'} eq '');
			$cat{$$hash{'name'}} = 0 if ($cat{$$hash{'name'}} eq '');
			$gData{'{category_list}'}[0] .= '<li><a href="' . $gData{'{site_cgi}'}[0] . '?cid=' . $$hash{'id'} . '">';
			$gData{'{category_list}'}[0] .= $$hash{'name'} . '</a> (' . $cat{$$hash{'name'}} . ')</li>' . "\n";
		}
		$gData{'{category_list}'}[0] .= '</ul>';
		$gEnv{'block'}{'category'} = 1;
	}
	{ # ̥
		my @order = sort { $b <=> $a } keys(%mon);
		$gData{'{archives_list}'}[0] = '<ul>';
		foreach my $base ( @order ) {
			my $yr = substr($base,0,4);
			my $mo = substr($base,4,2);
			$mo = $gMsg{'month'}{'enlong'}[int($mo - 1)];
			$gData{'{archives_list}'}[0] .= '<li><a href="' . &sbcms_monthlylink($base) . '">';
			$gData{'{archives_list}'}[0] .= $mo . ' ' . $yr . '</a> (' . $mon{$base} . ')</li>' . "\n";
		}
		$gData{'{archives_list}'}[0] .= '</ul>';
		$gEnv{'block'}{'archives'} = 1;
	}
	return();
}
sub sbcms_calendar {
	my $month = shift;
	$month = &sbtime_stamp($gNowTime,'%yr%mo',$gEnv{'conf'}{'timezone'},'en') if ($month eq '');
	my $yr = substr($month,0,4);
	my $mo = substr($month,4,2);
	my $wk = &sbtime_weekday($yr,$mo,1); # 
	my $ed = &sbtime_lastday($yr,$mo);
	my $td = &sbtime_stamp($gNowTime,'%yr%mo%dy',$gEnv{'conf'}{'timezone'},'en');
	my %ent = ();
	my %cal = {'tab'=>'','hor'=>'','ver'=>''};
	{ # ȥ꡼н
		use Time::Local;
		my $chk_st = timelocal(0,0,0,1,($mo-1),$yr);
		my $chk_ed = timelocal(59,59,23,$ed,($mo-1),$yr);
		foreach my $hash ( @{$gData{'ent'}} ) {
			next if ($$hash{'id'} eq '');
			next if ($$hash{'stat'} == 0); # ȥ꡼
			next if ($$hash{'date'} < $chk_st);
			next if ($$hash{'date'} > $chk_ed);
			$ent{&sbtime_stamp($$hash{'date'},'%yr%mo%dy',$gEnv{'conf'}{'timezone'},'en')} = 1;
		}
	}
	my $pr = ($mo != 1)  ? $yr . &sbtime_pad0($mo - 1) : ($yr - 1) . '12';
	my $nx = ($mo != 12) ? $yr . &sbtime_pad0($mo + 1) : ($yr + 1) . '01';
	$pr = '<a href="' . &sbcms_monthlylink($pr) . '">&lt;&lt;</a>';
	$nx = '<a href="' . &sbcms_monthlylink($nx) . '">&gt;&gt;</a>';
	{ # ǽν
		$gData{'{calendar}'}[0] = '<table border="0" cellspacing="0" cellpadding="0" class="calendar">' . "\n";
		$gData{'{calendar2}'}[0]  = '<table border="0" cellspacing="0" cellpadding="0" class="calendar">' . "\n";
		$gData{'{calendar2}'}[0] .= '<tr>' . "\n" . '<td colspan="7" class="calendar_month">' . $pr . ' ';
		$gData{'{calendar2}'}[0] .= &sbtime_mname($mo - 1,'long','en') . ' ' . $yr . ' ' . $nx . '</td>' . "\n" . '</tr>' . "\n";
		$gData{'{calendar2}'}[0] .= '<td class="weekday">Sun</td><td class="weekday">Mon</td><td class="weekday">Tue</td><td class="weekday">Wed</td>';
		$gData{'{calendar2}'}[0] .= '<td class="weekday">Thu</td><td class="weekday">Fri</td><td class="weekday">Sat</td></tr>' . "\n";
		$gData{'{calendar_vertical}'}[0] = '<br />' . "\n" . $mo . '<br />' . "\n" . '--<br />' . "\n";
		$gData{'{calendar_horizontal}'}[0] = $pr . ' <span class="calendar_month">' . &sbtime_mname($mo - 1,'long','en') . ' ' . $yr . '</span> | ';
	}
	for (my $d=1;$d<=$ed;$d++) { # 
		my $w = ($d - 1 + $wk) % 7;
		my $check = $month . &sbtime_pad0($d);
		$cal{'tab'} .= '<tr>' if ($d == 1 or ($w == 0 and $d > 1));
		$cal{'tab'} .= ('<td class="cell">&nbsp;</td>' x $w) if ($d == 1 and $w > 0);
		$cal{'tab'} .= '<td class="cell">';
		if ($ent{$check}) {
			$cal{'tab'} .= '<a href="' . $gData{'{site_cgi}'}[0] . '?day=' . $check . '">';
			$cal{'hor'} .= '<a href="' . $gData{'{site_cgi}'}[0] . '?day=' . $check . '">';
			$cal{'ver'} .= '<a href="' . $gData{'{site_cgi}'}[0] . '?day=' . $check . '">';
		}
		{ # ɽ
			$cal{'tab'} .= ($check eq $td) ? '<span class="today">' . $d . '</span>' : $d;
			$cal{'hor'} .= ($check eq $td) ? '<span class="today">' . $d . '</span>' : $d;
			$cal{'ver'} .= ($check eq $td) ? '<span class="today">' . $d . '</span>' : $d;
		}
		if ($ent{$check}) {
			$cal{'tab'} .= '</a>';
			$cal{'hor'} .= '</a>';
			$cal{'ver'} .= '</a>';
		}
		$cal{'tab'} .= '</td>';
		$cal{'hor'} .= ' ';
		$cal{'ver'} .= '<br />' . "\n";
		$cal{'tab'} .= ('<td class="cell">&nbsp;</td>' x (6 - $w)) if ($d == $ed);
		$cal{'tab'} .= '</tr>' . "\n" if ($d == $ed or $w == 6);
	}
	{ # Ǹν
		$gData{'{calendar}'}[0] .= $cal{'tab'} . '<td colspan="7"><div style="text-align: center;" class="calendar_month">';
		$gData{'{calendar}'}[0] .= $pr .  ' ' . &sbtime_mname($mo - 1,'long','en') . ' ' . $yr . ' ' . $nx . '</div></td></tr>' . "\n" . '</table>' . "\n";
		$gData{'{calendar2}'}[0] .= $cal{'tab'} . '</table>';
		$gData{'{calendar_vertical}'}[0] .= $cal{'ver'} . '--<br />' . "\n" . $nx . '<br />' . "\n";
		$gData{'{calendar_vertical}'}[0] .= $pr . '<br />' . "\n" . '--<br />' . "\n";
		$gData{'{calendar_horizontal}'}[0] .= $cal{'hor'} . $nx . "\n";
	}
	$gEnv{'block'}{'calendar'} = 1;
	return();
}
sub sbcms_search_entry {
	my ($eid,$text) = @_;
	my $flag = 0;
	&sbfile_read_entry($eid);
	my $data = $gData{'entry'}{$eid}{'ent'};
	my $subj = $$data{'subj'};
	my $body = &sbtxt_lfconv(&sbtxt_det($$data{'body'}),1);
	my $more = &sbtxt_lfconv(&sbtxt_det($$data{'more'}),1);
	$body =~ tr/\n//d;
	$more =~ tr/\n//d;
	$flag = ($gEnv{'code'} eq 'euc') ? &sbtxt_findword($subj,$text) : (index($subj,$text) > -1);
	$flag = ($gEnv{'code'} eq 'euc') ? &sbtxt_findword($body,$text) : (index($body,$text) > -1) if (!$flag);
	$flag = ($gEnv{'code'} eq 'euc') ? &sbtxt_findword($more,$text) : (index($more,$text) > -1) if (!$flag and $more ne '');
	delete($gData{'entry'}{$eid}); # Ѥȥ꡼ǡ
	return($flag);
}
sub sbcms_extract_entry {
	my $mode = shift;
	return() if ($gData{'num'}{'ent'} < 1);
	my @entry = @{$gData{'ent'}};
	my @new = ();
	@entry = sort { $$b{'date'} <=> $$a{'date'} } @entry;
	foreach my $hash ( @entry ) {
		next if ($$hash{'id'} eq '');
		next if ($$hash{'stat'} == 0); # ȥ꡼Ф
		push(@new,$hash);
	}
	if ($mode eq 'arc') {
		@entry = ();
		if ($gIn{'search'} ne '') { # 
			my $text = &sbtxt_decform($gIn{'search'},1);
			foreach my $hash ( @new ) {
				push(@entry,$hash) if (&sbcms_search_entry($$hash{'id'},$text));
			}
			$gData{'{selected_archive}'}[0] = 'Search: ' . $text;
			$mode = 'search=' . &sbtxt_urienc($gIn{'search'});
		}
		if ($gIn{'cid'} ne '') { # ƥ꡼
			my $cat = $gData{'cat'}[$gIn{'cid'}]{'name'};
			foreach my $hash ( @new ) {
				next if ($cat ne $$hash{'cat'});
				push(@entry,$hash);
			}
			$gData{'{site_title}'}[0] .= ' | ' . $cat;
			$gData{'{selected_archive}'}[0] = $cat;
			$mode = 'cid=' . $gIn{'cid'};
		}
		if ($gIn{'month'} ne '') { # ̥
			foreach my $hash ( @new ) {
				my $check = &sbtime_stamp($$hash{'date'},'%yr%mo',$gEnv{'conf'}{'timezone'},'en');
				next if ($gIn{'month'} ne $check);
				push(@entry,$hash);
			}
			$gData{'{site_title}'}[0] .= ' | ' . $gIn{'month'};
			$gData{'{selected_archive}'}[0] = $gIn{'month'};
			$mode = 'month=' . $gIn{'month'};
		}
		if ($gIn{'day'} ne '') { # ̥
			foreach my $hash ( @new ) {
				my $check = &sbtime_stamp($$hash{'date'},'%yr%mo%dy',$gEnv{'conf'}{'timezone'},'en');
				next if ($gIn{'day'} ne $check);
				push(@entry,$hash);
			}
			$gData{'{site_title}'}[0] .= ' | ' . $gIn{'day'};
			$gData{'{selected_archive}'}[0] = $gIn{'day'};
			$mode = 'day=' . $gIn{'day'};
		}
		@new = ();
		@entry = reverse(@entry) if ($gEnv{'conf'}{'archive_sort'} == 0);
	}
	if ($mode eq 'page' or $gEnv{'conf'}{'page_disp'}) { # ڡ
		if ($mode eq 'page') {
			@entry = ($gEnv{'conf'}{'entry_sort'}) ? @new : reverse(@new);
			@new = ();
		}
		my $all = @entry;
		my $page = $gIn{'page'};
		my $disp = $gEnv{'conf'}{'entry_disp'};
		$page = 0 if ($page eq '');
		$disp = 1 if ($disp < 1);
		$gData{'{page_num}'}[0] = int($all / $disp);
		$gData{'{page_num}'}[0]++ if ($all % $disp != 0 and $all > 0);
		$gData{'{page_now}'}[0] = ($page + 1);
		$gData{'{prev_page_url}'}[0] = $gData{'{site_cgi}'}[0] . '?page=' . ($page - 1) if ($page != 0);
		$gData{'{next_page_url}'}[0] = $gData{'{site_cgi}'}[0] . '?page=' . ($page + 1) if ($page < ($gData{'{page_num}'}[0] - 1));
		$gData{'{prev_page_url}'}[0] .= '&amp;' . $mode if ($mode ne 'page' and $gData{'{prev_page_url}'}[0] ne '');
		$gData{'{next_page_url}'}[0] .= '&amp;' . $mode if ($mode ne 'page' and $gData{'{next_page_url}'}[0] ne '');
		$gData{'{prev_page_link}'}[0] = '<a href="' . $gData{'{prev_page_url}'}[0] . '">&lt;&lt;</a>' if ($page != 0);
		$gData{'{next_page_link}'}[0] = '<a href="' . $gData{'{next_page_url}'}[0] . '">&gt;&gt;</a>' if ($page < ($gData{'{page_num}'}[0] - 1));
		@entry = splice(@entry,$page * $disp,$disp);
		$gEnv{'block'}{'page'} = 1;
	}
	{ # ȥ꡼ꥹ
		my $dt = $gEnv{'disptime'}{$gEnv{'conf'}{'disptime'}}{'dateinlist'};
		my $tl = $gEnv{'disptime'}{$gEnv{'conf'}{'disptime'}}{'time_lang'};
		$gData{'{selected_entry_list}'}[0] = '<ul>';
		foreach my $hash ( @entry ) {
			$gData{'{selected_entry_list}'}[0] .= '<li><a href="' . &sbcms_permalink($$hash{'id'},$$hash{'date'}) . '">';
			$gData{'{selected_entry_list}'}[0] .= $$hash{'subj'} . '</a>';
			$gData{'{selected_entry_list}'}[0] .= &sbtime_stamp($$hash{'date'},$dt,$gEnv{'conf'}{'timezone'},$tl) . '</li>' . "\n";
		}
		$gData{'{selected_entry_list}'}[0] .= '</ul>';
		$gEnv{'block'}{'selected_entry'} = 1;
	}
	return(@entry);
}
sub sbcms_entry {
	my ($eid,$num,$mode) = @_;
	&sbfile_read_entry($eid);
	my $data = $gData{'entry'}{$eid}{'ent'};
	my $dt = $gEnv{'disptime'}{$gEnv{'conf'}{'disptime'}}{'entry_date'};
	my $tm = $gEnv{'disptime'}{$gEnv{'conf'}{'disptime'}}{'entry_time'};
	my $tl = $gEnv{'disptime'}{$gEnv{'conf'}{'disptime'}}{'time_lang'};
	$gData{'{entry_id}'}[$num]        = $eid;
	$gData{'{permalink}'}[$num]       = &sbcms_permalink($eid,$$data{'date'});
	$gData{'{entry_permalink}'}[$num] = &sbcms_permalink($eid,$$data{'date'});
	$gData{'{entry_date}'}[$num]      = &sbtime_stamp($$data{'date'},$dt,$gEnv{'conf'}{'timezone'},$tl);
	$gData{'{entry_time}'}[$num]      = '<a href="' . &sbcms_permalink($eid,$$data{'date'}) . '">' . &sbtime_stamp($$data{'date'},$tm,$gEnv{'conf'}{'timezone'},$tl) . '</a>';
	$gData{'{entry_disp_time}'}[$num] = &sbtime_stamp($$data{'date'},$tm,$gEnv{'conf'}{'timezone'},$tl); # [add] ver 0.17
	$gData{'{user_name}'}[$num]       = &sbcms_entry_authlink($$data{'auth'});
	$gData{'{user_id}'}[$num]         = $$data{'auth'}; # [add] ver 0.17
	$gData{'{category_name}'}[$num]   = &sbcms_entry_catlink($$data{'cat'});
	$gData{'{category_id}'}[$num]     = &sbcms_entry_catid($$data{'cat'}); # [add] ver 0.17
	$gData{'{comment_num}'}[$num]     = ($$data{'acm'} > 0) ? '<a href="' . &sbcms_permalink($eid,$$data{'date'},'com') . '">comments (' . $$data{'com'} . ')</a>' : '-';
	$gData{'{trackback_num}'}[$num]   = ($$data{'atb'} > 0) ? '<a href="' . &sbcms_permalink($eid,$$data{'date'},'tb') . '">trackback (' . $$data{'tb'} . ')</a>' : '-';
	$gData{'{comment_count}'}[$num]   = $$data{'com'}; # [add] ver 0.17
	$gData{'{trackback_count}'}[$num] = $$data{'tb'};  # [add] ver 0.17
	$gData{'{entry_title}'}[$num]     = $$data{'subj'};
	$gData{'{trackback_auto_discovery}'}[$num] = &sbcms_tbauto_rdf($eid) if ($$data{'atb'} > 0);
	{ # ʸ/³
		my $body = &sbtxt_det($$data{'body'});
		my $more = &sbtxt_det($$data{'more'});
		$body = ($$data{'form'}) ? &sbtxt_lfconv($body,2) : &sbtxt_lfconv($body,1);
		$more = ($$data{'form'}) ? &sbtxt_lfconv($more,2) : &sbtxt_lfconv($more,1);
		$more = '<a href="' . &sbcms_permalink($eid,$$data{'date'},'more') . '">' . $gMsg{'parts'}{'sequel'} . '</a>' if ($mode ne 'ent' and $more ne '');
		$gData{'{entry_description}'}[$num] = $body;
		$gData{'{entry_sequel}'}[$num]      = $more;
	}
	if ($mode eq 'ent') { # ɽ̽
		$gData{'{entry_description}'}[$num] .= '<a name="sequel"></a>' if ($gData{'{entry_sequel}'}[$num] ne '');
		$gData{'{trackback_url}'}[$num] = $gData{'{site_cgi}'}[0] . '/' . $eid;
		$gData{'{site_title}'}[0] .= ' | ' . $$data{'subj'};
		$gEnv{'block'}{'comment'}   = &sbcms_entry_comment($gData{'entry'}{$eid}{'com'},'com');
		$gEnv{'block'}{'trackback'} = &sbcms_entry_comment($gData{'entry'}{$eid}{'tb'},'tb');
		if ($$data{'acm'} > 0) { # å
			$gData{'{cookie_name}'}[$num]  = $gIn{'name'};
			$gData{'{cookie_email}'}[$num] = $gIn{'email'};
			$gData{'{cookie_url}'}[$num]   = $gIn{'url'};
		}
		if ($$data{'acm'} > 0) { # ȴϢν
			$gEnv{'block'}{'comment_area'} = 1;
			$gData{'{sb_comment_js}'}[0] = '<script type="text/javascript" src="' . $gEnv{'srv'}{'base'} . $gEnv{'dir'}{'log'} . $gEnv{'file'}{'cook'} . '"></script>';
			&sbfile_read_datafile('img') if ($gIn{'num'}{'img'} eq '');
			$gData{'{comment_iconform}'}[$num]  = '<div id="icon_form"><select name="icon" id="icon" onchange="previewCommentIcon(this.value);">';
			$gData{'{comment_iconform}'}[$num] .= '<option value="">' . $gMsg{'parts'}{'no_icon'} . '</option>' . "\n";
			for (my $i=$gData{'num'}{'img'}-1;$i>=0;$i--) {
				next if ($gData{'img'}[$i]{'id'} eq '');
				next if ((split(':',$gData{'img'}[$i]{'stat'}))[1] == 0);
				$gData{'{comment_iconform}'}[$num] .= '<option value="' . $gData{'img'}[$i]{'id'} . '">' . $gData{'img'}[$i]{'name'} . '</option>' . "\n";
			}
			$gData{'{comment_iconform}'}[$num] .= '</select><span>[icon]</span></div>' . "\n";
		}
		$gEnv{'block'}{'trackback_area'} = 1 if ($$data{'atb'} > 0);
		&sbcms_entry_navi($eid);
	} else {
		$gData{'{sb_entry_marking}'}[$num] = '<a id="' . $gEnv{'basic'}{'preid'} . $eid . '"></a>' if ($gEnv{'basic'}{'marking'});
		$gEnv{'block'}{'comment_area'} = 0;
		$gEnv{'block'}{'trackback_area'} = 0;
		$gEnv{'block'}{'comment'} = 0;
		$gEnv{'block'}{'trackback'} = 0;
	}
	delete($gData{'entry'}{$eid}); # Ѥȥ꡼ǡ
	return();
}
sub sbcms_tbauto_rdf {
	my $eid = shift;
	my $out = '';
	my $aDescLen = 200;
	my $data = $gData{'entry'}{$eid}{'ent'};
	my $link = &sbcms_permalink($eid,$$data{'date'});
	my $subj = $$data{'subj'};
	my $auth = $$data{'auth'};
	my $tzpr = substr($gEnv{'conf'}{'timezone'},0,3) . substr($gEnv{'conf'}{'timezone'},3,2);
	my $date = &sbtime_stamp($$data{'date'},'%yr-%mo-%dyT%hr:%mi:%sc' . $tzpr,$gEnv{'conf'}{'timezone'},'en');
	my $ping = $gData{'{site_cgi}'}[0] . '/' . $eid;
	my $sum  = &sbcms_make_summary($$data{'sum'},$$data{'body'},$aDescLen);
	$out = <<"_TRACKBACK_AUTO_DISCOVERY_";
<!--
<rdf:RDF xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"
         xmlns:dc=\"http://purl.org/dc/elements/1.1/\"
         xmlns:trackback=\"http://madskills.com/public/xml/rss/module/trackback/\">
<rdf:Description
   rdf:about=\"$link\"
   dc:identifier=\"$link\"
   dc:title=\"$subj\"
   dc:description=\"$sum\"
   dc:creator=\"$auth\"
   dc:date=\"$date\"
   trackback:ping=\"$ping\" />
</rdf:RDF>
-->
_TRACKBACK_AUTO_DISCOVERY_
	return($out);
}
sub sbcms_make_summary {
	my ($sum,$body,$len) = @_;
	$sum = ($sum eq '') ?  &sbtxt_lfconv(&sbtxt_det($body),1) : $sum;
	$sum = &sbtxt_rmvtag($sum,$gEnv{'code'});
	$sum =~ tr/\x0D\x0A//d;
	$sum = (length($sum) > $len) ? &sbtxt_clip($sum,0,$len,$gEnv{'code'}) . '...' : $sum;
	return($sum);
}
sub sbcms_entry_comment {
	my ($data,$type) = @_;
	my $aTbLength = 300; # ȥåХåʸ
	my $num = 0;
	my $tm = $gEnv{'disptime'}{$gEnv{'conf'}{'disptime'}}{'msg_time'};
	my $tl = $gEnv{'disptime'}{$gEnv{'conf'}{'disptime'}}{'time_lang'};
	my @order = @{$data};
	@order = reverse(@order) if ($gEnv{'conf'}{$type . '_sort'} == 1);
	&sbfile_read_datafile('img') if ($type eq 'com' and $gIn{'num'}{'img'} eq '');
	foreach my $elem ( @order ) {
		next if ($$elem{'id'} eq '');
		next if ($$elem{'stat'} == 0);
		my $date = &sbtime_stamp($$elem{'date'},$tm,$gEnv{'conf'}{'timezone'},$tl);
		if ($type eq 'com') {
			$gData{'{comment_description}'}[$num] = &sbtxt_lfconv(&sbtxt_det($$elem{'body'}),2);
			$gData{'{comment_description}'}[$num] =~ s/s?https?:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:\@&=+\$,%#]+/<a href="$&" target="_blank">$&<\/a>/g;
			$gData{'{comment_name}'}[$num] = ($$elem{'url'} ne '') ? '<a href="' . $$elem{'url'} . '" target="_blank">' . $$elem{'auth'} . '</a>' : $$elem{'auth'};
			$gData{'{comment_time}'}[$num] = $date;
			if ($$elem{'icon'} ne '' and $gData{'img'}[$$elem{'icon'}]{'id'} ne '') {
				my $src = $gEnv{srv}{base} . $gEnv{dir}{img} . $gData{'img'}[$$elem{'icon'}]{'file'};
				my $alt = $gData{'img'}[$$elem{'icon'}]{'name'};
				my ($w,$h) = &sbpict_size($gEnv{dir}{base} . $gEnv{dir}{img} . $gData{'img'}[$$elem{'icon'}]{'file'});
				$gData{'{comment_icon}'}[$num]  = '<img src="' . $src . '" width="' . $w . '" height="' . $h . '" ';
				$gData{'{comment_icon}'}[$num] .= 'alt="' . $alt . '" title="' . $alt . '" class="comment_icon" />';
			} else {
				$gData{'{comment_icon}'}[$num] = '';
			}
		} else {
			$gData{'{trackback_title}'}[$num] = '<a href="' . $$elem{'url'} . '" target="_blank">' . $$elem{'subj'} . '</a>';
			$gData{'{trackback_excerpt}'}[$num] = &sbcms_make_summary('',$$elem{'body'},$aTbLength);
			$gData{'{trackback_blog_name}'}[$num] = $$elem{'name'};
			$gData{'{trackback_time}'}[$num] = $date;
		}
		$num++;
	}
	return($num);
}
sub sbcms_entry_navi {
	my $eid = shift;
	my @buf = @{$gData{'ent'}};
	my @entry = ();
	my $check = -1;
	@buf = sort { $$b{'date'} <=> $$a{'date'} } @buf;
	for (my ($i,$num)=(0,0);$i<@buf;$i++) {
		next if (${$buf[$i]}{'id'} eq '');
		next if (${$buf[$i]}{'stat'} == 0); # ȥ꡼Ф
		push(@entry,$buf[$i]);
		$check = $num if (${$buf[$i]}{'id'} == $eid);
		$num++;
	}
	foreach my $tag ('next_permalink','next_title','next_entry','prev_permalink','prev_title','prev_entry') { # 
		$gData{'{' . $tag . '}'}[0] = '';
	}
	if ($check > 0) {
		$gData{'{next_permalink}'}[0] = &sbcms_permalink(${$entry[$check - 1]}{'id'},${$entry[$check - 1]}{'date'});
		$gData{'{next_title}'}[0] = ${$entry[$check - 1]}{'subj'};
		$gData{'{next_entry}'}[0] = '<a href="' . $gData{'{next_permalink}'}[0] . '">' . $gData{'{next_title}'}[0] . ' &gt;&gt;</a>';
	}
	if ($check > -1 and $check < $#entry) {
		$gData{'{prev_permalink}'}[0] = &sbcms_permalink(${$entry[$check + 1]}{'id'},${$entry[$check + 1]}{'date'});
		$gData{'{prev_title}'}[0] = ${$entry[$check + 1]}{'subj'};
		$gData{'{prev_entry}'}[0] = '<a href="' . $gData{'{prev_permalink}'}[0] . '">&lt;&lt; ' . $gData{'{prev_title}'}[0] . '</a>';
	}
	return();
}
sub sbcms_entry_catlink {
	my $cat = shift;
	my $out = '';
	if ($cat eq '') {
		$out = '-';
	} else {
		my $id = &sbcms_entry_catid($cat);
		$out = ($id ne '') ? '<a href="' . $gData{'{site_cgi}'}[0] . '?cid=' . $id . '">' . $cat . '</a>' : $cat;
	}
	return($out);
}
sub sbcms_entry_catid {
	my $cat = shift;
	my $out = '';
	if ($cat ne '') {
		foreach my $hash ( @{$gData{'cat'}} ) {
			next if ($$hash{'id'} eq '');
			next if ($$hash{'name'} ne $cat);
			$out = $$hash{'id'};
		}
	}
	return($out);
}
sub sbcms_entry_authlink {
	my $auth = shift;
	my $out = '';
	$auth = 0 if ($gData{'user'}[$auth]{'id'} eq '');
	my $real = ($gData{'user'}[$auth]{'real'} ne '') ? $gData{'user'}[$auth]{'real'} : $gData{'user'}[$auth]{'name'};
	$out = '<a href="' . $gData{'{site_cgi}'}[0] . '?pid=' . $auth . '">' . $real . '</a>';
	return($out);
}
sub sbcms_permalink {
	my ($eid,$date,$mode) = @_;
	my $out = '';
	my $type = $gEnv{'conf'}{'entry_archive'};
	if ($type eq 'Individual') {
		$out = $gEnv{'srv'}{'base'} . $gEnv{'dir'}{'log'} . $gEnv{'basic'}{'preid'} . $eid . $gEnv{'basic'}{'suffix'};
		$out .= '#comments' if ($mode eq 'com');
		$out .= '#trackback' if ($mode eq 'tb');
		$out .= '#sequel' if ($mode eq 'more');
	} elsif ($type eq 'Monthly' and $mode eq '') {
		$date = &sbtime_stamp($date,'%yr%mo',$gEnv{'conf'}{'timezone'},'en');
		$out = $gEnv{'srv'}{'base'} . $gEnv{'dir'}{'log'} . $date . $gEnv{'basic'}{'suffix'} . '#' . $gEnv{'basic'}{'preid'} . $eid;
	} else {
		$out = $gData{'{site_cgi}'}[0] . '?eid=' . $eid;
		$out .= '#comments' if ($mode eq 'com');
		$out .= '#trackback' if ($mode eq 'tb');
		$out .= '#sequel' if ($mode eq 'more');
	}
	return($out);
}
sub sbcms_monthlylink {
	my $base = shift;
	my $out = '';
	if ($gEnv{'conf'}{'entry_archive'} eq 'Monthly') {
		my $file = $gEnv{'dir'}{'base'} . $gEnv{'dir'}{'log'} . $base . $gEnv{'basic'}{'suffix'};
		$out = (-e $file) ? $gEnv{'srv'}{'base'} . $gEnv{'dir'}{'log'} . $base . $gEnv{'basic'}{'suffix'} : $gData{'{site_cgi}'}[0] . '?month=' . $base;
	} else {
		$out = $gData{'{site_cgi}'}[0] . '?month=' . $base;
	}
	return($out);
}
1;
