#!/usr/bin/perl
# 
# library - response 
# == scripted by Takuya Otani ========
# == copyright (C) SimpleBoxes 2004 ==

{
	my $aVersion_ = 0.08;
	# 
	# ver 0.00 [2004/05/21] 
	# ver 0.01 [2004/06/04] ȥåХå˲ѴԤ褦
	# ver 0.02 [2004/06/08] Ūκݤ˥եƤ񤭽ФƤޤХ
	# ver 0.03 [2004/06/16] ȥåХåѥեǥ sbres_tbchar ɲ
	# ver 0.04 [2004/07/12] ȥб
	# ver 0.05 [2004/07/14] ƤΥХ
	# ver 0.06 [2004/07/19] ȥåХåΥХ
	# ver 0.07 [2004/07/21] եåѹ
	# ver 0.08 [2004/07/22] Ƚ߻ʸХ / sbres_comchar ɲ
	require 'sbhtml.pl';
	require 'sbtext.pl';
}

sub sbres_tb {
	my $eid = shift;
	my $lfile = &sblock_lock() or die($gMsg{'error'}{'file_lock'} . "\n");
	eval {
		my ($subj,$url,$body,$name,$check) = ();
		my ($host,$addr,$refe,$agnt) = &sbhtml_gethost();
		{ # եɹ
			&sbfile_read_datafile('ent');
			&sbfile_read_datafile('tb');
			&sbfile_read_entry($eid);
		}
		{ # 
			$subj = &sbres_tbchar($gIn{'title'},1);
			$url  = &sbres_tbchar($gIn{'url'},1);
			$body = &sbres_tbchar($gIn{'excerpt'},2);
			$name = &sbres_tbchar($gIn{'blog_name'},1);
			$gIn{'title'} = '';
			$gIn{'url'} = '';
			$gIn{'excerpt'} = '';
			$gIn{'blog_name'} = '';
		}
		{ # å
			die('url field is necessary.' . "\n") if ($url eq '');
			die('The ping is denied.' . "\n") if ( $gData{'entry'}{$eid}{'ent'}{'atb'} == 0 );
			die('The ping is denied.' . "\n") if ( !&sbres_check_ip($addr) );
			die('The ping has already received.' . "\n") if ( !&sbres_check_redundancy($eid,'tb',$body,$url) );
		}
		{ # ǡ
			require 'sbgen.pl';
			my $num = @{$gData{'entry'}{$eid}{'tb'}};
			$gData{'entry'}{$eid}{'tb'}[$num]{'id'}   = $gData{'num'}{'tb'};
			$gData{'entry'}{$eid}{'tb'}[$num]{'wid'}  = 0;
			$gData{'entry'}{$eid}{'tb'}[$num]{'eid'}  = $eid;
			$gData{'entry'}{$eid}{'tb'}[$num]{'stat'} = ($gData{'entry'}{$eid}{'ent'}{'atb'} == 1) ? 1 : 0;
			$gData{'entry'}{$eid}{'tb'}[$num]{'date'} = $gNowTime;
			$gData{'entry'}{$eid}{'tb'}[$num]{'body'} = $body;
			$gData{'entry'}{$eid}{'tb'}[$num]{'subj'} = $subj;
			$gData{'entry'}{$eid}{'tb'}[$num]{'name'} = $name;
			$gData{'entry'}{$eid}{'tb'}[$num]{'url'}  = $url;
			$gData{'entry'}{$eid}{'tb'}[$num]{'host'} = $addr;
			&sbini_creat_newtb($eid,$gData{'entry'}{$eid}{'tb'}[$num]{'stat'},$gNowTime,$subj,$name,$url);
			$gData{'entry'}{$eid}{'ent'}{'tb'} = &sbres_count($eid,'tb');
			$gData{'ent'}[$eid]{'tb'} = $gData{'entry'}{$eid}{'ent'}{'tb'};
			&sbfile_update_entry($eid);
			&sbfile_update_datafile('tb');
			&sbfile_update_datafile('ent');
			&sbres_build_files($eid);
		}
	};
	&sblock_unlock($lfile) if (!$@);
	&sbres_tb_xml($@);
	exit(0);
}
sub sbres_tbchar { # form ǥɽ
	my ($text,$flag) = @_; # ϥѥ᡼ / $flag : 1 ѴԤ, 2 ѴԤ
	my %charset = ('euc-jp' => 'euc', 'shift_jis' => 'sjis', 'utf-8' => 'utf8', 'iso-2022-jp' => 'jis');
	$text =~ s/\x0D\x0A/\n/g;
	$text =~ tr/\x0D\x0A/\n\n/;
	$gIn{'charset'} = $charset{lc($gIn{'charset'})} if ($gIn{'charset'} ne '');
	$gIn{'charset'} = 'utf8' if ($gIn{'charset'} eq '');
	if ($flag) {
		$text = &sblang_conv($text,$gEnv{'code'},$gIn{'charset'});
		$text = &sbtxt_ent($text);
		$text = &sbtxt_lfconv($text,0) if ($flag > 1);
	}
	return($text);
}
sub sbres_tb_xml {
	my $err = shift;
	print 'Content-Type: text/xml;',"\n\n";
	print '<?xml version="1.0" encoding="iso-8859-1"?>',"\n";
	print '<response>',"\n";
	print '<error>1</error>',"\n" if ($err);
	print '<message>',$err,'</message>',"\n" if ($err);
	print '<error>0</error>',"\n" if (!$err);
	print '</response>',"\n";
	return();
}
sub sbres_com {
	my $eid = shift;
	my $cookie = ($gIn{'set_cookie'}) ? &sbhtml_cookie($gEnv{'basic'}{'cooktag'},8544,'basic') : ''; # 8544 = 356 days
	my $lfile = &sblock_lock() or die($gMsg{'error'}{'file_lock'} . "\n");
	eval {
		my ($body,$name,$mail,$url,$icon,$check) = ();
		my ($host,$addr,$refe,$agnt) = &sbhtml_gethost();
		{ # եɹ
			&sbfile_read_datafile('ent');
			&sbfile_read_datafile('com');
			&sbfile_read_entry($eid);
		}
		{ # 
			$body = &sbres_comchar($gIn{'description'},1);
			$body = &sbtxt_lfconv(&sbtxt_ent($body),0);
			$name = &sbres_comchar($gIn{'name'},1);
			$mail = &sbres_comchar($gIn{'email'},1);
			$url  = &sbres_comchar($gIn{'url'},1);
			$icon = int($gIn{'icon'}) if ($gIn{'icon'} ne '');
			$gIn{'name'}  = '';
			$gIn{'email'} = '';
			$gIn{'url'}   = '';
		}
		{ # å
			$check = &sbres_check_ip($addr);
			$check = &sbres_check_redundancy($eid,'com',$body,$name) if ($check);
		}
		if ( $gData{'entry'}{$eid}{'ent'}{'acm'} > 0 and $check ) { # ǡ
			require 'sbgen.pl';
			my $num = @{$gData{'entry'}{$eid}{'com'}};
			$gData{'entry'}{$eid}{'com'}[$num]{'id'}   = $gData{'num'}{'com'};
			$gData{'entry'}{$eid}{'com'}[$num]{'wid'}  = 0;
			$gData{'entry'}{$eid}{'com'}[$num]{'eid'}  = $eid;
			$gData{'entry'}{$eid}{'com'}[$num]{'stat'} = ($gData{'entry'}{$eid}{'ent'}{'acm'} == 1) ? 1 : 0;
			$gData{'entry'}{$eid}{'com'}[$num]{'date'} = $gNowTime;
			$gData{'entry'}{$eid}{'com'}[$num]{'body'} = $body;
			$gData{'entry'}{$eid}{'com'}[$num]{'agnt'} = $agnt;
			$gData{'entry'}{$eid}{'com'}[$num]{'auth'} = $name;
			$gData{'entry'}{$eid}{'com'}[$num]{'host'} = $addr;
			$gData{'entry'}{$eid}{'com'}[$num]{'mail'} = $mail;
			$gData{'entry'}{$eid}{'com'}[$num]{'icon'} = $icon;
			$gData{'entry'}{$eid}{'com'}[$num]{'url'}  = $url;
			&sbini_creat_newcomment($eid,$gData{'entry'}{$eid}{'com'}[$num]{'stat'},$gNowTime,$name,$addr);
			$gData{'entry'}{$eid}{'ent'}{'com'} = &sbres_count($eid,'com');
			$gData{'ent'}[$eid]{'com'} = $gData{'entry'}{$eid}{'ent'}{'com'};
			&sbfile_update_entry($eid);
			&sbfile_update_datafile('ent');
			&sbfile_update_datafile('com');
			&sbres_build_files($eid);
		}
		$gIn{'name'}  = $name;
		$gIn{'email'} = $mail;
		$gIn{'url'}   = $url;
	};
	die($@ . "\n") if ($@);
	&sblock_unlock($lfile);
	$gIn{'eid'} = $eid;
	return('ent',$cookie);
}
sub sbres_comchar { # form ǥɽ
	my ($text,$flag) = @_; # ϥѥ᡼ / $flag : 1 ѴԤ, 2 ѴԤ
	my %charset = ('euc-jp' => 'euc', 'shift_jis' => 'sjis', 'utf-8' => 'utf8', 'iso-2022-jp' => 'jis');
	$text =~ s/\x0D\x0A/\n/g;
	$text =~ tr/\x0D\x0A/\n\n/;
	$gIn{'charset'} = $charset{lc($gIn{'charset'})} if ($gIn{'charset'} ne '');
	$gIn{'charset'} = $gEnv{'code'} if ($gIn{'charset'} eq '');
	if ($flag) {
		$text = &sblang_conv($text,$gEnv{'code'},$gIn{'charset'});
		$text = &sbtxt_ent($text);
		$text = &sbtxt_lfconv($text,0) if ($flag > 1);
	}
	return($text);
}
sub sbres_build_files {
	my $eid = shift;
	require 'sbmake.pl';
	if ($gEnv{'conf'}{'entry_archive'} eq 'Individual') {
		&sbmake_comjs();
		&sbmake_entry($eid);
		&sbmake_top();
	} else {
		&sbmake_rebuild_all();
	}
}
sub sbres_check_ip {
	my $addr = shift;
	my $check = 1;
	my $ban_list = &sbtxt_lfconv($gEnv{'conf'}{'ip_ban'},1);
	foreach my $ban_ip ( split("\n",$ban_list) ) {
		$check = 0 if ($addr =~ /$ban_ip/);
		last if (!$check);
	}
	return($check);
}
sub sbres_check_redundancy {
	my ($eid,$mode,$body,$name) = @_;
	my $check = 1;
	foreach my $hash ( @{$gData{'entry'}{$eid}{$mode}} ) {
		next if ($$hash{'id'} eq '');
		if ($mode eq 'com') {
			$check = 0 if ($name eq $$hash{'auth'} and $body eq $$hash{'body'});
		} else {
			$check = 0 if ($name eq $$hash{'url'} and $body eq $$hash{'body'});
		}
		last if (!$check);
	}
	return($check);
}
sub sbres_count {
	my ($eid,$mode) = @_;
	my $num = 0;
	foreach my $hash ( @{$gData{'entry'}{$eid}{$mode}} ) {
		next if ($$hash{'id'} eq '');
		next if ($$hash{'stat'} == 0);
		$num++;
	}
	return($num);
}
1;
